%% Problem 2
%% Discrete Fourier Transform
ppg = readmatrix('ppg_100hz_1024samples.csv');
fs = 100;
PPG = fft(ppg); 
N=length(PPG);
%% Plot FFT and finding frequency with maximum magnitude
figure
stem(fs/N*(1:length(PPG)/2), abs(PPG(1:end/2)))
xlabel('f (Hz)','FontSize', 15) 
ylabel ('|PPG(f)|','FontSize', 15)
xlim([0 fs/2])
title('(a) DFT of PPG Signal','FontSize', 18)

% Find frequency with maximum magnitude
[M, I_PPG] = max(abs(PPG(1:end/2)));
PPG_maxmag = fs*(I_PPG - 1)/length(PPG);
fprintf("Frequency of highest magnitude in the FFT is "+PPG_maxmag+" Hz.\n")
fprintf("Heart rate computed using FFT is "+PPG_maxmag*60+" beats per min.\n")

%% Plot Autocorrelation

[c_ppg, lags_ppg] = xcorr(ppg, 'coeff');
figure
stem(lags_ppg(ceil(end/2):end), c_ppg(ceil(end/2):end));
xlabel('Time Lag (k)','FontSize', 15)
ylabel ('c_{PPG}(k)','FontSize', 15)
title('(b) Normalized Autocorrelation','FontSize', 18)

% Downward zero crossing for PPG
firstcrossing = 0;
for i = floor(length(c_ppg)/2):length(c_ppg)
    if c_ppg(i) > 0 && c_ppg(i+1) < 0
        if firstcrossing == 0
            firstcrossing = 1;
            firstindex = i;
        else
            freq_ppg = 1/((i - firstindex)/fs);
            break
        end
    end
end
fprintf("Frequency computed using autocorrelation is "+PPG_maxmag+" Hz.\n")
fprintf("Heart rate computed using autocorrelation is "+freq_ppg*60+" beats per min.\n")
