%% Problem 3
%% Defining input signals and filter H
clearvars
close all
h=fir1(100,0.5,'low');
[x1,Fs1] = audioread('x1.mp4');
[x2,Fs2]=audioread('x2.mp4');
% Note that Fs1=Fs2. They can thus be used interchangeably
% Also note that x1 and x2 are of equal length
Fs=Fs1; % or equal to Fs2
len=length(x1); % or length(x2)

%% For System-1
% Plotting the frequency response of input signals
figure
freqz(x1)
title('System-1: Frequency response of x_1')
figure
freqz(x2)
title('System-1: Frequency response of x_2')

% Multiplying x2 with (-1)^n
x22=zeros(len,1);
for k=1:length(x2)
    x22(k) = (-1)^(k-1) * x2(k);
end

z=x1+x22;
figure
freqz(z)
title('System-1: Frequency response of z')

%Multiplying sum with (-1)^n
z2=zeros(len,1);
for k=1:length(z)
    z2(k) = (-1)^(k-1) * z(k);
end
% Output signals
 y1(:,1)=conv(h,z);
 y2(:,1)=conv(h,z2);

figure
freqz(y1)
title('System-1: Frequency response of y_1')
figure
freqz(y2)
title('System-1: Frequency response of y_2')

% To listen
sound(z,Fs)
pause(30)
sound(y1,Fs)
pause(30)
sound(y2,Fs)
pause(30)

%% For System-2

clear y1 y2 z
%Convolving audio signal with LPF
x1_new(:,1)=conv(h,x1);
x2_new(:,1)=conv(h,x2);
 
% Plotting the frequency response of input signals
figure
freqz(x1_new) % First channel alone
title('System-2: Frequency response of x_1 after LPF')
figure
freqz(x2_new)
title('System-2: Frequency response of x_2 after LPF')

%Multiplying X2 with (-1)^n
x22=zeros(len,1);
for k=1:length(x2_new)
    x22(k) = (-1)^(k-1) * x2_new(k);
end

z=x1_new+x22;
figure
freqz(z)
title('System-2: Frequency response of z')

%Multiplying sum with (-1)^n
z2=zeros(len,1);
for k=1:length(z)
    z2(k) = (-1)^(k-1) * z(k);
end
% Output signals
y1(:,1)=conv(h,z);
y2(:,1)=conv(h,z2);
figure
freqz(y1)
title('System-2: Frequency response of y_1')
figure
freqz(y2)
title('System-2: Frequency response of y_2')

%To listen
sound(z,Fs)
pause(30)
sound(y1,Fs)
pause(30)
sound(y2,Fs)
pause(30)

%% Observations
% For System-1, the output z is the sum of x1 and x2(-1)^n. While you can hear the former in z, the multiplication by (-1)^n turns x2 to a high-frequency component, making it sound noisy. y2 is almost the same as x2 and y1 has x1 along with some noisy component from x2. This is because x2 had a sound component in the high-frequency range (up to almost 0.85 pi). These when multiplied by (-1)^n showed up in lower ranges and hence they were not fully filtered by the LPF H.
% 
% For System-2, the observations are similar for z and y2. Since the LPF H removed the high-frequency components of x2 initially, the noisy effects of x2 in y1 is lesser in this case. However, the noise is not completely eliminated as H is just a 100 tap FIR filter (not the ideal LPF). Increasing the order would help to further reduce the noise. 