%% Problem 4
%% (a) Initialize and create sinc function
clearvars
close all
l=100;
w=(-1024:1024)/(1024); %-pi to pi
n=-l:l; % length of input sequence
x=sinc(n/4)/4;
% using custom function to calculate and plot DTFT
calculateDTFTandplot(x,n,l,w,'x[n]','X')

%% (b) Delay input by 10 samples
delay=10;
xb=[zeros(1,delay) x];
nb=-l:(l+delay);
calculateDTFTandplot(xb,nb,l,w,'x_1[n] = x[n-10]','X_1')

%% (c) Reversing sequence: x[-n]
xc=flip(x);
calculateDTFTandplot(xc,n,l,w,'x_2[n] = x[-n]','X_2')

%% (d) Multiply by n
xd=n.*x;
calculateDTFTandplot(xd,n,l,w,'x_3[n] = nx[n]','X_3')

%% (e) Multiplying by exponential
xe=exp(1i*n*pi/6).*x;
calculateDTFTandplot(xe,n,l,w,'x_4[n] = e^{jn\pi/6}x[n]','X_4')

%% (f) Multiplying by (-1)^n 
xf=((-1).^n).*x;
calculateDTFTandplot(xf,n,l,w,'x_5[n] = (-1)^{n}x[n]','X_5')

%% (g) Self-Convolution
xg=conv(x,x);
ng=-2*l:2*l;
calculateDTFTandplot(xg,ng,2*l,w,'x_6[n] = x[n]*x[n]','X_6')

%% (h) Square
xh=x.*x; % or x.^2
calculateDTFTandplot(xh,n,l,w,'x_7[n]=x^2[n]','X_7')

%% (i) Downsampling by 2
xi=downsample(x,2);
ni=-l/2:l/2;
calculateDTFTandplot(xi,ni,l/2,w,'x_8[n]=x[2n]','X_8')

%% (j) Upsampling by 2
xj=upsample(x,2);
nj=-2*l:2*l+1;
calculateDTFTandplot(xj,nj,2*l,w,'x_9[n]=x[n/2]','X_9')

%% Testing freqz function 
figure
freqz(x) % Can be repeated for all the sequences

%% Function Definition
function calculateDTFTandplot(x,n,l,w,imtitle1,seq)
    H=zeros(1,length(w));
    for k=min(n):max(n)
        H=H+x(k+l+1)*exp(-1i*w*pi*k);
    end
    figure
    subplot(3,1,1)
    plot(n,real(x)) 
    % Section(e) produces complex values for x. Hence real(x)
    title(imtitle1)
    xlim([min(n) max(n)])
    subplot(3,1,2)
    plot(w,abs(H))
    imtitle1="|"+seq+"(e^{j\omega})|";
    title(imtitle1)
    subplot(3,1,3)
    plot(w,angle(H)*180/pi)
    imtitle1="\angle"+seq+"(e^{j\omega}) in degrees";
    title(imtitle1)
end

%% Comments
% The DTFT is not a perfect rectangle for the sinc signal, and the magnitude plot of X3 varies
% from theoretical calculation. These occur as we do not use an infinetely
% long sinc signal / we use a windowed version of an infinitely long sinc
% signal.