%% Problem 10
%% Initialization and comments
% The logic is coded seperately for each sub-question for better
% understanding. Note that this way is ineffecient as it uses a loop to
% iterate over all the samples for each sub-question. It is actually better
% and saves time to use a single for loop and build all the logic within.
clearvars
close all
mat = dir('*.mat'); 
ch=1;

%% Part-a: Spectrogram

x=[];
for index=1:length(mat)
    load(mat(index).name);
    x=[x data];
end
Fs=ceil(freq); % Made as integer as spectrogram command requires an integer as sampling frequency.

[S,F,T,P]=spectrogram(x(ch,:),100,80,100,Fs);
figure(1)
surf(T,F,20*log10(abs(S)),'edgecolor','none'); axis tight;
view(2)% for top-view
xlabel('Time (Seconds)')
ylabel('Frequency (Hz)')
title("Spectrogram for Dog-1 Channel 1")


%% Part-b: Welch's PSD estimation

ictal=[];
for index=1:178
    load(mat(index).name);
    ictal=[ictal data(ch,:)];
end

interictal=[];
for index=179:length(mat)
    load(mat(index).name);
    interictal=[interictal data(ch,:)];
end
[p_ictal,w1]=pwelch(ictal);
[p_interictal,w]=pwelch(interictal);

figure(2)
plot(w1/pi,smoothdata(10*log10(p_ictal)))
hold on
plot(w/pi,smoothdata(10*log10(p_interictal)))
hold off
xlabel('Normalized frequency \omega / \pi')
ylabel('PSD (in log scale)')
title("Welch's estimate of PSD for ictal and interictal clips for Channel 1")
legend('Ictal','Interictal')
  
    
%% Part-c: Average PSD as a feature
 
for index=1:length(mat)
    load(mat(index).name);
    pxx=pwelch(data(ch,:));
    Power(index)=mean(pxx);
end
figure(3)
stem(Power)
xlabel('Clips')
ylabel('Mean PSD of the clip')
title('PSD as a feature')
 