%% Problem 8
%% Time domain signal processing : Features from EEG data
clearvars
close all
% Ensure tochange the directory to the location of training data

% Ensure that test clips are removed from that folder and saved seperately
% so that the folder only has ictal and interictal clips
mat = dir('*.mat'); 
ch=1;
for index=1:length(mat)
    % Loading the file
    load(mat(index).name);
     
    % Taking the time series corresponding to your specified row (channel)
    x=data(ch,:);
    ts=1/freq;

    % Statistical parameters - Mean, median and mode
    Mean(index)=mean(x);
    Median(index)=median(x);
    Mode(index)=mode(x);

    %Finding the energy of the signal
    Energy(index)=sumsqr(x);


    % Finding the Hjorth parameters
     
        % Hjorth Activity is the variance of the time domain signal
        activity(index)=var(x);

        % Mobility
        Mobility(index)=mobility(x,ts); 
        % mobility(x,ts) is a custom function.

        % Complexity
        der_x=diff(x)/ts;
        Complexity(index)=mobility(der_x,ts)/mobility(x,ts);
        % Using a function to calculate mobility
        % makes it easier to compute the complexity


    % Total length of the curve - Sum of distances between successive points
    L(index)=sum(abs(diff(x)));

end

% Plot the 8 parameters using appropriate labels and titles.
figure
stem(Mean)
xlabel('Segments')
ylabel('Mean value')
title('Mean value for EEG segments')

figure
stem(Median)
xlabel('Segments')
ylabel('Median value')
title('Median value for various segments')

figure
stem(Mode)
xlabel('Segments')
ylabel('Mode value')
title('Mode value for various segments')

figure
stem(Energy)
xlabel('Segments')
ylabel('Energy value')
title('Energy value for various segments')

figure
stem(activity)
xlabel('Segments')
ylabel('Activity value')
title('Hjorth Activity value for various segments')

figure
stem(Mobility)
xlabel('Segments')
ylabel('Mobility value')
title('Hjorth Mobility value for various segments')

figure
stem(Complexity)
xlabel('Segments')
ylabel('Complexity value')
title('Hjorth Complexity value for various segments')

figure
stem(L)
xlabel('Segments')
ylabel('Total Line Length value')
title('Total Line Length value for various segments')


% Defining custom function for mobility
function mob = mobility(x,dt)
    den=var(x); % Denominator
    der = diff(x)/dt; %Derivative
    num=var(der); % Numerator
    mob=sqrt(num/den);
end