%% Problem 9
%% Instantaneous amplitude and instantaneous frequency from Hilbert transform

clearvars
close all
ch=1; % Channel
mat = dir('*.mat'); 
for index=1:length(mat)
    load(mat(index).name);
    x=data(ch,:); % Loading each clip and choosing the desired channel
    x_d=bandpass(x,[1 4],freq); % Delta Band
    x_a=bandpass(x,[8 12],freq); % Alpha band
    x_dh=hilbert(x_d);
    inst_amp=abs(x_dh); % Instantaneous amplitude
    ia(index)=mean(inst_amp); % Mean instantaneous amplitude
    x_ah=hilbert(x_a);
    instfrq = freq/(2*pi)*diff(unwrap(angle(x_dh))); % instantaneous frequency
    ifreq(index)=mean(instfrq); % Mean instantaneous frequency
end

 
% Plot
figure
stem(ia)
xlabel('Clips')
title('Instantaneous amplitude')

figure
stem(ifreq)
xlabel('Clips')
title('Instantaneous frequency')